//------------------------------------------------------------------ 
#property copyright "www.forex-tsd.com" 
#property link      "www.forex-tsd.com" 
//------------------------------------------------------------------
#property indicator_separate_window 
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_width1  2
#property indicator_level1  25
#property indicator_level2  75
#property indicator_minimum -5
#property indicator_maximum 105

//
//
//
//
//

extern int RsiPeriod    = 13;
extern int RsiPrice     = PRICE_CLOSE;
extern int MinMaxPeriod = 10;
extern int SumPeriod    = 3;
double exs[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init() 
{
   SetIndexBuffer(0,exs);
      IndicatorShortName("Exit swing ("+RsiPeriod+")"); 
   return(0); 
} 

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][3];
#define _rsi 0
#define _max 1
#define _min 2

int start() 
{ 
   int i,k,r,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][_rsi] = iRSI(NULL,0,RsiPeriod,RsiPrice,i);
      work[r][_min] = work[r][_rsi];
      work[r][_max] = work[r][_rsi];
         for (k=1; k<MinMaxPeriod; k++)
         {
            work[r][_min] = MathMin(work[r][_min],work[r-k][_rsi]);
            work[r][_max] = MathMax(work[r][_max],work[r-k][_rsi]);
         }
         double sumc=0;
         double sume=0;
         for (k=0; k<SumPeriod; k++)
         {
            sumc += work[r-k][_rsi]-work[r-k][_min];
            sume += work[r-k][_max]-work[r-k][_min];
         }
         
         //
         //
         //
         //
         //
         
         if (sume != 0)
               exs[i] = 100.0*sumc/sume;
         else  exs[i] = 0;             
   } 
   return(0); 
}